/*******************************************************************************
 * FoxProjectile_CloudBase generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxProjectile_CloudBase extends FoxProjectile_GrenadeBase
    abstract
    native(Weapon)
    config(Projectile)
    hidecategories(Navigation);

var transient float LastCloudUpdate;
var const float CloudUpdatePeriod;
var bool bActive;
var const float CloudExpirationTime;
var const float CloudFadeoutTime;

simulated function Tick(float DeltaTime)
{
    local FoxPawn FP;

    super(Actor).Tick(DeltaTime);
    // End:0x131
    if(((Role == ROLE_Authority) && bActive) && (LastCloudUpdate + CloudUpdatePeriod) < WorldInfo.RealTimeSeconds)
    {
        LastCloudUpdate = WorldInfo.RealTimeSeconds;
        // End:0x130
        foreach CollidingActors(class'FoxPawn', FP, DamageRadius, Location)
        {
            FP.TakeRadiusDamage(InstigatorController, Damage * CloudUpdatePeriod, DamageRadius, MyDamageType, MomentumTransfer, Location, false, self, DamageFalloff);            
        }        
    }
    //return;    
}

// Export UFoxProjectile_CloudBase::execGetEffectTime(FFrame&, void* const)
native function float GetEffectTime();

simulated function Explode(Vector HitLocation, Vector HitNormal)
{
    super.Explode(HitLocation, HitNormal);
    // End:0x49
    if(bHideMeshOnExplode)
    {
        Mesh.SetHidden(true);
    }
    bActive = true;
    SetPhysics(6);
    //return;    
}

simulated function StopTrailEmitterComponent()
{
    //return;    
}

simulated function Emitter GrenadeExplosion(Vector HitLocation, Vector HitNormal, bool bOnGround)
{
    local Emitter NewExplosionEmitter;

    NewExplosionEmitter = super.GrenadeExplosion(HitLocation, HitNormal, bOnGround);
    // End:0x5B
    if(NewExplosionEmitter != none)
    {
        NewExplosionEmitter.SetBase(self);
    }
    SetTimer(CloudExpirationTime, false, 'CloudExpire');
    return NewExplosionEmitter;
    //return ReturnValue;    
}

simulated function CloudExpire()
{
    bActive = false;
    Mesh.SetHidden(true);
    // End:0x63
    if(ExplosionEmitter != none)
    {
        ExplosionEmitter.LifeSpan = CloudFadeoutTime;
    }
    //return;    
}

defaultproperties
{
    CloudUpdatePeriod=0.20
    CloudExpirationTime=7.50
    CloudFadeoutTime=5.0
    begin object name=StaticMeshComponent0 class=StaticMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: StaticMeshComponent'Default__FoxProjectile_CloudBase.StaticMeshComponent0'
    Mesh=StaticMeshComponent0
    bHideMeshOnExplode=false
    DestructionTimer=12.50
    ProjLightEnvironment=DynamicLightEnvironmentComponent'Default__FoxProjectile_CloudBase.MyLightEnvironment'
    Damage=150.0
    DamageRadius=500.0
    begin object name=CollisionCylinder class=CylinderComponent
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxProjectile_CloudBase.CollisionCylinder'
    CylinderComponent=CollisionCylinder
    begin object name=CollisionCylinder class=CylinderComponent
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxProjectile_CloudBase.CollisionCylinder'
    Components(0)=CollisionCylinder
    Components(1)=DynamicLightEnvironmentComponent'Default__FoxProjectile_CloudBase.MyLightEnvironment'
    begin object name=StaticMeshComponent0 class=StaticMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: StaticMeshComponent'Default__FoxProjectile_CloudBase.StaticMeshComponent0'
    Components(2)=StaticMeshComponent0
    LifeSpan=15.50
    begin object name=CollisionCylinder class=CylinderComponent
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxProjectile_CloudBase.CollisionCylinder'
    CollisionComponent=CollisionCylinder
}